#include "js-gtk.h"

JSGTK_CLASS(Adjustment);

static JSBool adjustment_ctor (JSContext *cx, JSObject *obj,
			 uintN argc, jsval *argv, jsval *rval) {
    GtkWidget *adjustment;     
    jsdouble jd;
    gfloat gvals[6];
    int i;
    if (argc < 6 || !JSVAL_IS_NUMBER(argv[0]) ||
	!JSVAL_IS_NUMBER(argv[1]) ||
	!JSVAL_IS_NUMBER(argv[2]) ||
	!JSVAL_IS_NUMBER(argv[3]) ||
	!JSVAL_IS_NUMBER(argv[4]) ||
	!JSVAL_IS_NUMBER(argv[5]))
      return JS_FALSE;
    for (i=0; i<6; i++) {
      JS_ValueToNumber(cx, argv[i], &jd);
      gvals[i] = (gfloat) jd;
      /* DEBUG */
      /* printf("value#%d: %f\n", i, gvals[i]); */
    }
    /* is this better: ? */
/*    adjustment = gtk_adjustment_new( (JS_ValueToNumber(cx, argv[0], &jd)) ? (gfloat) jd : 0, */
    adjustment = gtk_adjustment_new(gvals[0],
				    gvals[1],
				    gvals[2],
				    gvals[3],
				    gvals[4],
				    gvals[5]);    
    JS_SetPrivate(cx,obj, adjustment);
    jsgtkobj_registerWrapper(cx, GTK_OBJECT(adjustment), obj);
    return JS_TRUE;
}
  
static JSBool adjustment_changed(JSContext *cx, JSObject *obj,
				 uintN argc, jsval *argv, jsval *rval) {  
  GtkAdjustment *adjustment;
  
  GET_GTK(adjustment,cx,obj,ADJUSTMENT);
  gtk_adjustment_changed(adjustment);
  return JS_TRUE;
}

static JSBool adjustment_value_changed(JSContext *cx, JSObject *obj,
				 uintN argc, jsval *argv, jsval *rval) {  
  GtkAdjustment *adjustment;
  
  GET_GTK(adjustment,cx,obj,ADJUSTMENT);
  gtk_adjustment_value_changed(adjustment);
  return JS_TRUE;
}

static JSBool adjustment_clamp_page(JSContext *cx, JSObject *obj,
				 uintN argc, jsval *argv, jsval *rval) {  
  GtkAdjustment *adjustment;
  jsdouble jd;
  gfloat arg1, arg2;
  if (argc < 2 || !JSVAL_IS_DOUBLE(argv[0]) || 
      !JSVAL_IS_DOUBLE(argv[1]))
    return JS_FALSE;
  GET_GTK(adjustment,cx,obj,ADJUSTMENT);
  JS_ValueToNumber(cx, argv[0], &jd);
  arg1 = (gfloat) jd;
  JS_ValueToNumber(cx, argv[1], &jd);
  arg2 = (gfloat) jd;
  gtk_adjustment_clamp_page(adjustment, arg1, arg2);
  return JS_TRUE;
}
static JSBool adjustment_set_value(JSContext *cx, JSObject *obj,
				 uintN argc, jsval *argv, jsval *rval) {  
  GtkAdjustment *adjustment;
  if (argc < 1 || !JSVAL_IS_DOUBLE(argv[0]))
    return JS_FALSE;
  GET_GTK(adjustment,cx,obj,ADJUSTMENT);
  gtk_adjustment_set_value(adjustment, (gfloat) JSVAL_TO_INT(argv[0]));
  return JS_TRUE;
}

static JSFunctionSpec adjustment_methods[] = {
    {"changed", adjustment_changed, 0},
    {"value_changed", adjustment_value_changed, 0},
    {"clamp_page", adjustment_clamp_page, 2},
    {"set_value", adjustment_set_value, 1},
    {0}
};

JSGTK_INIT_FUNC(adjustment,Adjustment,6);

