#include "js-gtk.h"

JSGTK_CLASS(Arrow);


static JSBool arrow_set(JSContext *cx, JSObject *obj,
			uintN argc, jsval *argv, jsval *rval) {
    GtkArrow *arrow;
    
    if (argc < 2 ||
	!JSVAL_IS_INT(argv[0]) || !JSVAL_IS_INT(argv[1])) 
	return JS_FALSE;
    GET_GTK(arrow,cx,obj,ARROW);
    gtk_arrow_set(arrow, JSVAL_TO_INT(argv[0]), JSVAL_TO_INT(argv[1]));
    
    return JS_TRUE;
}    

static JSFunctionSpec arrow_methods[] = {
    {"set",	arrow_set,	2},
    {0}
};


static JSBool arrow_ctor(JSContext *cx, JSObject *obj,
			 uintN argc, jsval *argv, jsval *rval) {
    GtkWidget *arrow;
    
    if (!JS_IsConstructing(cx))
	return JS_FALSE;
    
    if (argc < 2 ||
	!JSVAL_IS_INT(argv[0]) || !JSVAL_IS_INT(argv[1])) 
	return JS_FALSE;
    arrow = gtk_arrow_new(JSVAL_TO_INT(argv[0]), JSVAL_TO_INT(argv[1]));
    JS_SetPrivate(cx, obj, arrow);
    jsgtkobj_registerWrapper(cx, GTK_OBJECT(arrow), obj);
    return JS_TRUE;
}
	
JSGTK_INIT_FUNC(arrow,Arrow,2);

