#define JSFILE
#include <jsapi.h>
#include <assert.h>
#include "js-gtk.h"

/* From jsinit.c */
int init_doInit(JSContext **, JSObject **, int, char **);

main(int argc, char **argv) {
  JSContext *cx;
  JSObject *glob;
  JSScript *scr;
  jsval rval;
  
  assert(argc == 2);

  if (!init_doInit(&cx, &glob, argc, argv)) {
    printf("Initialization failed; aborting.\n");
    return;
  }
  
  scr = JS_CompileFile(cx, glob, argv[1]);
  if (scr == NULL) {
    printf("Couldn't compile script!\n");
    return;
  }
  if (!JS_ExecuteScript(cx, glob, scr, &rval)) {
    printf("Script execution failed!\n");
  }

}
