#include "js-gtk.h"

JSGTK_CLASS(Label);

static JSBool label_set(JSContext *cx, JSObject *obj,
			uintN argc, jsval *argv, jsval *rval) {
    GtkLabel *label;
    
    if (argc < 1 ||
	!JSVAL_IS_STRING(argv[0]))
	return JS_FALSE;
    
    GET_GTK(label,cx,obj,LABEL);
    gtk_label_set(label, JS_GetStringBytes(JSVAL_TO_STRING(argv[0])));
    return JS_TRUE;
}

static JSBool label_get(JSContext *cx, JSObject *obj,
			uintN argc, jsval *argv, jsval *rval) {
    GtkLabel *label;
    gchar *str;

    GET_GTK(label,cx,obj,LABEL);
    gtk_label_get(label, &str);
    *rval = STRING_TO_JSVAL(JS_NewStringCopyZ(cx, str));
    return JS_TRUE;
}

static JSBool label_ctor(JSContext *cx, JSObject *obj,
			 uintN argc, jsval *argv, jsval *rval) {
    GtkWidget *label;
    
    if (argc < 1 || !JSVAL_IS_STRING(argv[0])) {
	JS_ReportError(cx, "new GtkLabel() expects (string), got (%s)/%d\n",
		       JS_GetTypeName(cx, JS_TypeOfValue(cx, argv[0])));
	return JS_FALSE;
    }
    
    label = gtk_label_new(JS_GetStringBytes(JSVAL_TO_STRING(argv[0])));
    JS_SetPrivate(cx, obj, label);
    jsgtkobj_registerWrapper(cx, GTK_OBJECT(label), obj);
    return JS_TRUE;
}
	
static JSFunctionSpec label_methods[] = {
    {"set",	label_set,	1},
    {"get",	label_get,	0},
    {0}
};

JSGTK_INIT_FUNC(label,Label,0);
