#include "js-gtk.h"

JSGTK_CLASS(ProgressBar);

static JSBool progress_bar_update(JSContext *cx, JSObject *obj,
				  uintN argc, jsval *argv, jsval *rval) {
    GtkProgressBar *progress;

    if (argc < 1 ||
	!JSVAL_IS_NUMBER(argv[0]))
	return JS_FALSE;
    
    GET_GTK(progress,cx,obj,PROGRESS_BAR);
    if (JSVAL_IS_DOUBLE(argv[0]))
	gtk_progress_bar_update(progress, (gfloat) *JSVAL_TO_DOUBLE(argv[0]));
    else
	gtk_progress_bar_update(progress, (gfloat) JSVAL_TO_INT(argv[0]));
    
    return JS_TRUE;
}    

static JSFunctionSpec progress_bar_methods[] = {
    {"update",		progress_bar_update,		1},
    {0}
};

static JSBool progress_bar_set_percentage(JSContext *cx, JSObject *obj,
					  jsval id, jsval *vp) {
    if (JSVAL_TO_INT(id) != 42)
	return JS_FALSE;
    
    return progress_bar_update(cx, obj, 1, vp, vp);
}

/* JS 1999 02 27
static JSBool progress_bar_get_percentage(JSContext *cx, JSObject *obj,
					  jsval id, jsval *vp) {
    GtkProgressBar *progress;
    
    if (JSVAL_TO_INT(id) != 42)
	return JS_FALSE;
    
    GET_GTK(progress,cx,obj,PROGRESS_BAR);
    if (!JS_NewNumberValue(cx, progress->percentage, vp))
	return JS_FALSE;
    
    return JS_TRUE;
}
*/

static JSPropertySpec progress_bar_props[] = {
    {"percentage",	42,	JSPROP_ENUMERATE|JSPROP_PERMANENT,
     /* progress_bar_get_percentage, */ 
     progress_bar_set_percentage},
    {0}
};

static JSBool progress_bar_ctor(JSContext *cx, JSObject *obj,
				uintN argc, jsval *argv, jsval *rval) {
    GtkWidget *progress;
    
    if (!JS_IsConstructing(cx))
	return JS_FALSE;
    
    progress = gtk_progress_bar_new();
    if (!progress)
	return JS_FALSE;
    JS_SetPrivate(cx, obj, progress);
    jsgtkobj_registerWrapper(cx, GTK_OBJECT(progress), obj);
    
    return JS_TRUE;
}

JSBool jsgtkprogressbar_init(JSContext *cx, JSObject *global,
				    JSObject *gtkproto) {
    JSObject *progressProto;
    
    progressProto = JS_InitClass(cx, global, gtkproto,
				 &jsgtk_ProgressBarClass,
				 progress_bar_ctor, 0,
				 progress_bar_props,
				 progress_bar_methods,
				 NULL, NULL);
    if (!progressProto)
	return JS_FALSE;
    return JS_TRUE;
}
